#include "mainwindow.h"
#include "ui_mainwindow.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    QMainWindow::setWindowFlags(Qt::FramelessWindowHint);
    ui->setupUi(this);

    currentNumber = 0;
    choosenOperator = '+';
    pressedNumber = 0;

    ui->display->setText("");

    connect(ui->pushButton_quit, SIGNAL(clicked()), this, SLOT(close()));
    connect(ui->pushButton_0, SIGNAL(clicked()), this, SLOT(addNumber()));
    connect(ui->pushButton_1, SIGNAL(clicked()), this, SLOT(addNumber()));
    connect(ui->pushButton_2, SIGNAL(clicked()), this, SLOT(addNumber()));
    connect(ui->pushButton_3, SIGNAL(clicked()), this, SLOT(addNumber()));
    connect(ui->pushButton_4, SIGNAL(clicked()), this, SLOT(addNumber()));
    connect(ui->pushButton_5, SIGNAL(clicked()), this, SLOT(addNumber()));
    connect(ui->pushButton_6, SIGNAL(clicked()), this, SLOT(addNumber()));
    connect(ui->pushButton_7, SIGNAL(clicked()), this, SLOT(addNumber()));
    connect(ui->pushButton_8, SIGNAL(clicked()), this, SLOT(addNumber()));
    connect(ui->pushButton_9, SIGNAL(clicked()), this, SLOT(addNumber()));
    connect(ui->pushButton_dot, SIGNAL(clicked()), this, SLOT(addNumber()));

    connect(ui->pushButton_add, SIGNAL(clicked()), this, SLOT(addOperator()));
    connect(ui->pushButton_sub, SIGNAL(clicked()), this, SLOT(addOperator()));
    connect(ui->pushButton_div, SIGNAL(clicked()), this, SLOT(addOperator()));
    connect(ui->pushButton_mul, SIGNAL(clicked()), this, SLOT(addOperator()));
    connect(ui->pushButton_mod, SIGNAL(clicked()), this, SLOT(addOperator()));

    connect(ui->pushButton_quad, SIGNAL(clicked()), this, SLOT(addOperator()));
    connect(ui->pushButton_sqrt2, SIGNAL(clicked()), this, SLOT(addOperator()));
    connect(ui->pushButton_sqrt, SIGNAL(clicked()), this, SLOT(addOperator()));
    connect(ui->pushButton_power, SIGNAL(clicked()), this, SLOT(addOperator()));

    connect(ui->pushButton_calc, SIGNAL(clicked()), this, SLOT(calculate()));
    connect(ui->pushButton_clear, SIGNAL(clicked()), this,SLOT(clear()));



}

MainWindow::~MainWindow()
{
    delete ui;
}


void MainWindow::close()
{
    exit(0);
}

void MainWindow::addNumber()
{
    QString text = QObject::sender()->objectName();
    text.remove("pushButton_");

    //currentNumber = text.toFloat();

    if(text == "dot")
    {
        if(ui->display->text()=="")
        {
            ui->display->setText(ui->display->text()+"0.");
        }

        else
        {
            ui->display->setText(ui->display->text()+".");
        }
    }

    else if (text == "0" && ui->display->text()=="")
    {
        ui->display->setText(ui->display->text()+text+".");

    }

    else
    {
        ui->display->setText(ui->display->text()+text);
    }
}

void MainWindow::addOperator()
{
    currentNumber = ui->display->text().toFloat();
    ui->display->setText("");

    QString text = QObject::sender()->objectName();
    text.remove("pushButton_");

    if(text == "add")
    {
        choosenOperator = '+';
    }

    else if(text == "sub")
    {
        choosenOperator = '-';
    }

    else if(text == "mul")
    {
        choosenOperator = '*';
    }

    else if(text == "div")
    {
        choosenOperator = '/';
    }

    else if(text == "mod")
    {
        choosenOperator = '%';
    }

    else if(text == "quad")
    {
        choosenOperator = '2';
    }

    else if(text == "sqrt2")
    {
        choosenOperator = '4';
    }
    else if(text == "sqrt")
    {
        choosenOperator = '8';
    }
    else if(text == "power")
    {
        choosenOperator = '^';
    }
}

void MainWindow::calculate()
{
    pressedNumber = ui->display->text().toFloat();
    switch (choosenOperator)
    {
        case '+':       currentNumber = currentNumber+pressedNumber;
                        refreshDisplay();
                        break;

        case '-':       currentNumber = currentNumber-pressedNumber;
                        refreshDisplay();
                        break;

        case '*':       currentNumber = currentNumber*pressedNumber;
                        refreshDisplay();
                        break;

        case '/':       currentNumber = currentNumber/pressedNumber;
                        refreshDisplay();
                        break;

        case '%':       currentNumber = (float) (((int)(currentNumber+0.001f))%((int)(pressedNumber+0.001f)));
                        refreshDisplay();
                        break;
        case '2':       currentNumber = currentNumber*currentNumber;
                        refreshDisplay();
                        break;
        case '4':       currentNumber = sqrt(currentNumber);
                        refreshDisplay();
                        break;
        case '8':       currentNumber = pow(currentNumber, (1/pressedNumber));
                        refreshDisplay();
                        break;
        case '^':       currentNumber = pow(currentNumber, pressedNumber);
                        refreshDisplay();
                        break;
        case 's':       currentNumber = sin(currentNumber);
                        refreshDisplay();
                        break;
    }
}

void MainWindow::refreshDisplay()
{
    ui->display->setText(QString::number(currentNumber));
}

void MainWindow::clear()
{
    currentNumber = 0;
    choosenOperator ='+';
    pressedNumber = 0;
    ui->display->setText("");
}
